library verilog;
use verilog.vl_types.all;
entity adc_conversion_control is
    generic(
        IDLE            : integer := 0;
        START           : integer := 1;
        LATCH_COMMAND   : integer := 2;
        CHECK_BYTE_COUNT: integer := 3;
        MEMORY_RD_ASSERT_OE: integer := 4;
        MEMORY_RD_ADDRESS: integer := 5;
        MEMORY_RD_DATA  : integer := 6;
        MEMORY_RD_LATCH : integer := 7;
        MEMORY_RD_COMPLETE: integer := 8;
        ADC_CONVST_DELAY_COMPLETE: integer := 9
    );
    port(
        CLK             : in     vl_logic;
        RST_N           : in     vl_logic;
        ADC_CONVST_COMMAND_LATCH: in     vl_logic;
        ADC_CONVST_COMMAND: in     vl_logic_vector(7 downto 0);
        ADC_CONVST_DELAY_REGISTER: out    vl_logic_vector(23 downto 0);
        MEMORY_ADDRESS  : inout  vl_logic_vector(7 downto 0);
        MEMORY_DATA     : inout  vl_logic_vector(7 downto 0);
        MEMORY_WRITE_LATCH: out    vl_logic;
        MEMORY_READ_LATCH: out    vl_logic;
        MEMORY_OUTPUT_ENABLE: out    vl_logic;
        REQUEST_EN      : out    vl_logic;
        GRANT_RDY       : in     vl_logic
    );
    attribute mti_svvh_generic_type : integer;
    attribute mti_svvh_generic_type of IDLE : constant is 1;
    attribute mti_svvh_generic_type of START : constant is 1;
    attribute mti_svvh_generic_type of LATCH_COMMAND : constant is 1;
    attribute mti_svvh_generic_type of CHECK_BYTE_COUNT : constant is 1;
    attribute mti_svvh_generic_type of MEMORY_RD_ASSERT_OE : constant is 1;
    attribute mti_svvh_generic_type of MEMORY_RD_ADDRESS : constant is 1;
    attribute mti_svvh_generic_type of MEMORY_RD_DATA : constant is 1;
    attribute mti_svvh_generic_type of MEMORY_RD_LATCH : constant is 1;
    attribute mti_svvh_generic_type of MEMORY_RD_COMPLETE : constant is 1;
    attribute mti_svvh_generic_type of ADC_CONVST_DELAY_COMPLETE : constant is 1;
end adc_conversion_control;
