library verilog;
use verilog.vl_types.all;
entity i2c_comms_interface is
    generic(
        IDLE            : integer := 0;
        START           : integer := 1;
        LATCH_COMMAND   : integer := 2;
        CHECK_READ_WRITE_FLAG: integer := 3;
        MEMORY_RD_ASSERT_OE: integer := 4;
        MEMORY_RD_ADDRESS: integer := 5;
        MEMORY_RD_DATA  : integer := 6;
        MEMORY_RD_LATCH : integer := 7;
        MEMORY_RD_CHECK : integer := 8;
        MEMORY_RD_DELAY : integer := 9;
        START_I2C_TRANSMIT: integer := 10;
        WAIT_FOR_I2C_COMPLETE: integer := 11;
        CHECK_I2C_COMPLETE: integer := 12;
        START_I2C_TRANSMIT_DELAY: integer := 13;
        START_I2C_RECEIVE: integer := 14;
        MEMORY_WRITE_CYCLE: integer := 15;
        MEMORY_WR_ADDRESS: integer := 16;
        MEMORY_WR_DATA  : integer := 17;
        MEMORY_WR_LATCH : integer := 18
    );
    port(
        CLK             : in     vl_logic;
        RST_N           : in     vl_logic;
        SERIAL_CLK      : in     vl_logic;
        I2C_DATA        : inout  vl_logic;
        I2C_CLOCK       : out    vl_logic;
        MEMORY_ADDRESS  : inout  vl_logic_vector(7 downto 0);
        MEMORY_DATA     : inout  vl_logic_vector(7 downto 0);
        MEMORY_WRITE_LATCH: out    vl_logic;
        MEMORY_READ_LATCH: out    vl_logic;
        MEMORY_OUTPUT_ENABLE: out    vl_logic;
        I2C_COMMAND     : in     vl_logic_vector(7 downto 0);
        I2C_COMMAND_LATCH: in     vl_logic;
        I2C_TRANSMIT_COMPLETE: out    vl_logic;
        I2C_BYTE_RECEIVED: out    vl_logic;
        REQUEST_EN      : out    vl_logic;
        GRANT_RDY       : in     vl_logic
    );
    attribute mti_svvh_generic_type : integer;
    attribute mti_svvh_generic_type of IDLE : constant is 1;
    attribute mti_svvh_generic_type of START : constant is 1;
    attribute mti_svvh_generic_type of LATCH_COMMAND : constant is 1;
    attribute mti_svvh_generic_type of CHECK_READ_WRITE_FLAG : constant is 1;
    attribute mti_svvh_generic_type of MEMORY_RD_ASSERT_OE : constant is 1;
    attribute mti_svvh_generic_type of MEMORY_RD_ADDRESS : constant is 1;
    attribute mti_svvh_generic_type of MEMORY_RD_DATA : constant is 1;
    attribute mti_svvh_generic_type of MEMORY_RD_LATCH : constant is 1;
    attribute mti_svvh_generic_type of MEMORY_RD_CHECK : constant is 1;
    attribute mti_svvh_generic_type of MEMORY_RD_DELAY : constant is 1;
    attribute mti_svvh_generic_type of START_I2C_TRANSMIT : constant is 1;
    attribute mti_svvh_generic_type of WAIT_FOR_I2C_COMPLETE : constant is 1;
    attribute mti_svvh_generic_type of CHECK_I2C_COMPLETE : constant is 1;
    attribute mti_svvh_generic_type of START_I2C_TRANSMIT_DELAY : constant is 1;
    attribute mti_svvh_generic_type of START_I2C_RECEIVE : constant is 1;
    attribute mti_svvh_generic_type of MEMORY_WRITE_CYCLE : constant is 1;
    attribute mti_svvh_generic_type of MEMORY_WR_ADDRESS : constant is 1;
    attribute mti_svvh_generic_type of MEMORY_WR_DATA : constant is 1;
    attribute mti_svvh_generic_type of MEMORY_WR_LATCH : constant is 1;
end i2c_comms_interface;
