library verilog;
use verilog.vl_types.all;
entity spi_iface is
    generic(
        IDLE            : integer := 0;
        WAIT_FOR_START  : integer := 1;
        CHECK_FOR_DATA  : integer := 2;
        START_WRITE_BYTE: integer := 3;
        WRITE_BYTE      : integer := 4;
        DELAY_CHECK_BYTE_COUNT: integer := 5;
        CHECK_BYTE_COUNT: integer := 6;
        START_READ_BYTE : integer := 7;
        READ_BYTE       : integer := 8;
        CHECK_RD_BYTE   : integer := 9;
        READ_COMPLETE   : integer := 10;
        CLK_COUNT_4_4MHZ: integer := 5;
        CLK_COUNT_10_2MHZ: integer := 3;
        READ_SPI_DELAY_COUNT: vl_logic_vector(0 to 7) := (Hi0, Hi0, Hi0, Hi1, Hi0, Hi0, Hi0, Hi0)
    );
    port(
        CLK             : in     vl_logic;
        RST_N           : in     vl_logic;
        SPI_DATA_OUT    : out    vl_logic;
        SPI_CLK         : out    vl_logic;
        SPI_DATA_IN     : in     vl_logic;
        SPI_CS_N        : out    vl_logic;
        DIN             : in     vl_logic_vector(7 downto 0);
        WE_IN           : in     vl_logic;
        RDY_IN          : out    vl_logic;
        DOUT            : out    vl_logic_vector(7 downto 0);
        WE_OUT_N        : out    vl_logic;
        RDY_OUT         : in     vl_logic
    );
    attribute mti_svvh_generic_type : integer;
    attribute mti_svvh_generic_type of IDLE : constant is 1;
    attribute mti_svvh_generic_type of WAIT_FOR_START : constant is 1;
    attribute mti_svvh_generic_type of CHECK_FOR_DATA : constant is 1;
    attribute mti_svvh_generic_type of START_WRITE_BYTE : constant is 1;
    attribute mti_svvh_generic_type of WRITE_BYTE : constant is 1;
    attribute mti_svvh_generic_type of DELAY_CHECK_BYTE_COUNT : constant is 1;
    attribute mti_svvh_generic_type of CHECK_BYTE_COUNT : constant is 1;
    attribute mti_svvh_generic_type of START_READ_BYTE : constant is 1;
    attribute mti_svvh_generic_type of READ_BYTE : constant is 1;
    attribute mti_svvh_generic_type of CHECK_RD_BYTE : constant is 1;
    attribute mti_svvh_generic_type of READ_COMPLETE : constant is 1;
    attribute mti_svvh_generic_type of CLK_COUNT_4_4MHZ : constant is 1;
    attribute mti_svvh_generic_type of CLK_COUNT_10_2MHZ : constant is 1;
    attribute mti_svvh_generic_type of READ_SPI_DELAY_COUNT : constant is 1;
end spi_iface;
