library verilog;
use verilog.vl_types.all;
entity spi_tiny_slave_model is
    generic(
        IDLE            : integer := 0;
        RECEIVE_DATA    : integer := 1;
        SEND_TO_HOST    : integer := 2;
        RECEIVE_COMPLETE: integer := 3;
        WRITE_REGISTER  : integer := 4;
        LOAD_SHIFT_REG  : integer := 5;
        DELAY_WRITE_DATA_BYTE: integer := 6;
        WRITE_DATA_BYTE : integer := 7;
        WRITE_DATA_COMPLETE: integer := 8;
        BIT_COUNT_IDLE  : integer := 0;
        BIT_COUNT_CLK_HI: integer := 1;
        BIT_COUNT_CLK_LOW: integer := 2;
        BIT_COUNT_INC_BYTE: integer := 3;
        USB_RD_N_DELAY_COUNT: vl_logic_vector(0 to 15) := (Hi0, Hi0, Hi0, Hi0, Hi0, Hi0, Hi0, Hi0, Hi0, Hi1, Hi0, Hi0, Hi1, Hi1, Hi0, Hi1)
    );
    port(
        CLK             : in     vl_logic;
        RST_N           : in     vl_logic;
        SPI_DATA_OUT    : out    vl_logic;
        SPI_CLK         : in     vl_logic;
        SPI_DATA_IN     : in     vl_logic;
        SPI_CS_N        : in     vl_logic;
        USB_RXF_N       : in     vl_logic;
        USB_TXE_N       : in     vl_logic;
        USB_DATA        : inout  vl_logic_vector(7 downto 0);
        USB_RD_N        : out    vl_logic;
        USB_WR          : out    vl_logic;
        USB_SI          : out    vl_logic
    );
    attribute mti_svvh_generic_type : integer;
    attribute mti_svvh_generic_type of IDLE : constant is 1;
    attribute mti_svvh_generic_type of RECEIVE_DATA : constant is 1;
    attribute mti_svvh_generic_type of SEND_TO_HOST : constant is 1;
    attribute mti_svvh_generic_type of RECEIVE_COMPLETE : constant is 1;
    attribute mti_svvh_generic_type of WRITE_REGISTER : constant is 1;
    attribute mti_svvh_generic_type of LOAD_SHIFT_REG : constant is 1;
    attribute mti_svvh_generic_type of DELAY_WRITE_DATA_BYTE : constant is 1;
    attribute mti_svvh_generic_type of WRITE_DATA_BYTE : constant is 1;
    attribute mti_svvh_generic_type of WRITE_DATA_COMPLETE : constant is 1;
    attribute mti_svvh_generic_type of BIT_COUNT_IDLE : constant is 1;
    attribute mti_svvh_generic_type of BIT_COUNT_CLK_HI : constant is 1;
    attribute mti_svvh_generic_type of BIT_COUNT_CLK_LOW : constant is 1;
    attribute mti_svvh_generic_type of BIT_COUNT_INC_BYTE : constant is 1;
    attribute mti_svvh_generic_type of USB_RD_N_DELAY_COUNT : constant is 1;
end spi_tiny_slave_model;
